<template>
  <v-container
    style="height: 100%"
    fluid
  >
    <base-searchbar
      :filter-by="filterList"
      :filter-count="1"
      hide-status
      title="Students"
      icon="mdi-account-group"
      show-add-filter
      @trigger="$trigger"
      @refresh="bootstrap"
    />

    <v-tabs>
      <v-tab
        v-for="(currTab, tabKey) in tabs"
        :key="tabKey"
        link
        :to="currTab.to"
        v-text="currTab.text"
      />
    </v-tabs>

    <v-card>
      <v-data-table
        :headers="thead"
        :items="studentsList"
        class="elevation-1"
        :loading="dataStatus.subjectTable.loading"
      >
        <template #item.name="{ item }">
          <span class="cursor-pointer font-weight-bold">
            {{ item.fname }} {{ item.lname }}
          </span>
        </template>

        <template #item.status="{ item }">
          <v-chip
            draggable
            class="text-uppercase overline"
            :color="statusChipColor(item.status)"
            small
          >
            <small>{{ item.status }}</small>
          </v-chip>
        </template>

        <template #item.actions="{ item }">
          <v-btn
            v-if="item.status !== 'confirmed'"
            small
            color="primary"
            class="mr-1"
            @click="handleClickUpdateStatus({ item, status: 'confirmed' })"
          >
            <small>Approve</small>
          </v-btn>

          <v-btn
            v-if="item.status !== 'rejected'"
            small
            color="red"
            class="mr-1 white--text"
            @click="handleClickUpdateStatus({ item, status: 'rejected' })"
          >
            <small>Reject</small>
          </v-btn>
        </template>
      </v-data-table>
    </v-card>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

const getKey = (key, obj) => obj[key] === undefined ? obj.default : obj[key]

export default {
  name: 'AdminStudents',

  data: () => ({
    filterList: [
      { text: 'First Name', value: 'fname' },
      { text: 'Last Name', value: 'lname' }
    ],

    thead: [
      { text: 'Name', value: 'name' },
      { text: 'Username', value: 'username' },
      { text: 'Status', value: 'status' },
      { text: 'Date Registered', value: 'created_at' },
      { text: 'Actions', value: 'actions' }
    ],

    dataStatus: {
      subjectTable: { loading: true }
    }
  }),

  computed: {
    ...mapState('users', {
      studentsList: 'list',
      studentsCount: 'count'
    }),

    tabs () {
      return [
        { text: 'Pending', to: { name: 'Students', params: { status: 'pending' } } },
        { text: 'Confirmed', to: { name: 'Students', params: { status: 'confirmed' } } },
        { text: 'Rejected', to: { name: 'Students', params: { status: 'rejected' } } }
      ]
    }
  },

  watch: {
    $route: {
      async handler (data) {
        await this.bootstrap({ ...data.query })
      },

      immediate: true
    }
  },

  methods: {
    ...mapActions('users', {
      getUsersList: 'list',
      updateUser: 'update'
    }),

    statusChipColor (status) {
      return getKey(status, {
        pending: 'gray',
        confirmed: 'success',
        rejected: 'red'
      })
    },

    getStudentsList (e) {
      return this.getUsersList({
        ...e,
        level: 'student',
        status: this.$route.params.status
      })
    },

    bootstrap (payload) {
      const config = {
        loading: 'dataStatus.subjectTable.loading'
      }

      this.statusWrapper(async () => {
        await this.getStudentsList({ ...payload })
      }, config)
    },

    handleClickUpdateStatus ({ item, status }) {
      const success = async () => {
        try {
          await this.updateUser({
            user_id: item.user_id,
            status: status
          })

          await this.getStudentsList({ ...this.$route.query })
          return this.$alert({ type: 'success' })
        } catch (error) {
          this.$alert({ type: 'error' })
        }
      }

      this.$prompt({ success })
    }
  }
}
</script>
